--[[ $Id$
   Copyright (c) Brett England, 2013
   Copyright (c) Mark Baldwin, 2013

   No commercial use.
   No redistribution at profit.
   All derivative work must retain this message and
   acknowledge the work of the original author.
--]]



local xap = require "xap"
local widget = require "widget" 
local storyboard = require "storyboard"
local ui = require "ui"
local scene = storyboard.newScene()


function scene:createScene( event )
	local group = self.view
	local background = display.newImageRect( "background.png", 800, 480)
	background.x = display.contentWidth/2
	background.y = display.contentHeight/2 
	group:insert( background )
	
	-- Start XAP engine
	xap_server:start()

	-- Capture application shutdown		

	local onSystem = function( event )
						if event.type == "applicationExit" then
							xap_server:stop()
						end
					end

	local grid = {
	{
		  {c=ui.newLabel, bounds={0,0,display.contentWidth,50}, text="Conservatory Page", align="center", size=30}
	},
    { -- ROW 1
		{c=toggle, text="LR TV", xapSource="dbzoo.livebox.Controller:rf.3", size=10},
		{c=toggle, text="LR Lamp 1", xapSource="dbzoo.livebox.Controller:rf.1", size=10},
		{c=toggle, text="LR Lamp 2", xapSource="dbzoo.livebox.Controller:rf.5", size=10},
		{c=toggle, text="LR Games", xapSource="dbzoo.livebox.Controller:rf.2", size=10},
		{c=toggle, text="Kitchen TV", xapSource="dbzoo.livebox.Controller:rf.4", size=10},
		{c=toggle, text="Kitchen Lamp", xapSource="dbzoo.livebox.Controller:rf.6", size=10}
		
		
	},
	{ -- ROW 2
		{c=toggle, text="Spare C1", xapSource="dbzoo.livebox.Controller:rf.7", size=10},
		{c=toggle, text="Spare C2", xapSource="dbzoo.livebox.Controller:rf.8", size=10},
		{c=toggle, text="Spare C3", xapSource="dbzoo.livebox.Controller:rf.9", size=10},
		{c=toggle, text="Spare D1", xapSource="dbzoo.livebox.Controller:rf.10", size=10},
		{c=toggle, text="Spare D2", xapSource="dbzoo.livebox.Controller:rf.11", size=10},
		{c=toggle, text="Spare D3", xapSource="dbzoo.livebox.Controller:rf.12", size=10}		
	},
	{ -- ROW 3
		{c=toggle, text="Spare E1", xapSource="dbzoo.livebox.Controller:rf.13", size=10},
		{c=toggle, text="Spare E2", xapSource="dbzoo.livebox.Controller:rf.14", size=10},
		{c=toggle, text="Spare E3", xapSource="dbzoo.livebox.Controller:rf.15", size=10},
		{c=toggle, text="Spare F1", xapSource="dbzoo.livebox.Controller:rf.16", size=10},
		{c=toggle, text="Spare F2", xapSource="dbzoo.livebox.Controller:rf.17", size=10},
		{c=toggle, text="Spare F3", xapSource="dbzoo.livebox.Controller:rf.18", size=10}		
	},			 
--[[	{ -- ROW 3
		{},
		{c=button, icon="degC.png", label="Lounge", xapSource='dbzoo.livebox.jeenode:livingroom.temp'},
		{c=button, icon="degC.png", label="Kitchen", xapSource='dbzoo.livebox.jeenode:kitchen.temp'},
		{c=button, icon="degC.png", label="Outside", xapSource='dbzoo.livebox.jeenode:gas-monitor.temp'},
		{c=button, icon="degC.png", label="HAH Internal", xapSource='dbzoo.livebox.controller:1wire.1'}		 
	},
	{ -- ROW 4
		{},
		{c=button, icon="lightbulb.png", label="Lounge", xapSource='dbzoo.livebox.jeenode:livingroom.light'},
		{c=button, icon="lightbulb.png", label="Kitchen", xapSource='dbzoo.livebox.jeenode:kitchen.light'},
		{c=button, icon="lightbulb.png", label="Outside", xapSource='dbzoo.livebox.jeenode:gas-monitor.light'},
		{},
		{},	
	}]]--
	}
			
	-- Render grid
	local ypos = 0, xpos
	for _,r in ipairs(grid) do		
		xpos=200
		for _,v in pairs(r) do
			if v.c then
				group:insert(v.c(v, xpos, ypos)) --mod here
			end
			xpos = xpos + 80
		end
		ypos = ypos + 80
	end
	
end

-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
--storyboard.removeScene(storyboard.getPrevious())
end

-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	storyboard.removeScene(storyboard.getCurrentSceneName())
	--display.remove(grid)	
end

-- If scene's view is removed, scene:destroyScene() will be called just prior to:
function scene:destroyScene( event )
	local group = self.view
	
	-- INSERT code here (e.g. remove listeners, remove widgets, save state variables, etc.)
	
end

-----------------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
-----------------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched whenever before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

-----------------------------------------------------------------------------------------

return scene
